Unit AFH6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFH6R(var IA :Array of Integer; var JA :Array of Integer;
                N :Integer; var IU :Array of Integer;
                var JU :Array of Integer; var IP :Array of Integer);

implementation

procedure AFH6R(var IA :Array of Integer; var JA :Array of Integer;
                N :Integer; var IU :Array of Integer;
                var JU :Array of Integer; var IP :Array of Integer);
var
NM,NH,I,JP,JPI,JPP,MIN,IAA,IAB,J,JJ,LAST,IUA,IUB,LH,L :Integer;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90;
begin

{           - }
{           }
{        A,    RR(U)U.  }
{          U  }
{         RR(U)U. }


{   IA, JA -    A; }

{        N -   A (: ); }

{   IU, JU -    U; }

{       IP -     N,   - }
{                }


{           IU  IP }

NM := N-1;
NH := N+1;
for I:=1 to N do
 begin
  IU[I-1] := 0;
_10:
  IP[I-1] := 0;
 end;
JP := 1;

{            A }

for I:=1 to NM do
 begin
  JPI := JP;
  JPP := N+JP-I;
  MIN := NH;
  IAA := IA[I-1];
  IAB := IA[I+0]-1;
  if ( IAB < IAA ) 
   then goto _30;

{         JJ,   }
{       I  A,   JA   JU }

  for J:=IAA to IAB do
   begin
    JJ := JA[J-1];
    JU[JP-1] := JJ;
    JP := JP+1;
    if ( JJ < MIN ) 
     then MIN := JJ;
_20:
    IU[JJ-1] := I;
   end;

{         ,    I }

_30:
  LAST := IP[I-1];
  if ( LAST = 0 ) 
   then goto _60;
  L := LAST;
_40:
  L := IP[L-1];
  LH := L+1;
  IUA := IU[L-1];
  IUB := IU[LH-1]-1;
  if ( LH = I ) 
   then IUB := JPI-1;
  IU[I-1] := I;

{        L  U }

  for J:=IUA to IUB do
   begin
    JJ := JU[J-1];
    if ( IU[JJ-1] = I ) 
     then goto _50;
    JU[JP-1] := JJ;
    JP := JP+1;
    IU[JJ-1] := I;
    if ( JJ < MIN ) 
     then MIN := JJ;
_50:
   end;
  if ( JP = JPP ) 
   then goto _70;
  if ( L <> LAST ) 
   then goto _40;
_60:
  if ( MIN = NH ) 
   then goto _90;

{        IU }

_70:
  L := IP[MIN-1];
  if ( L = 0 ) 
   then goto _80;
  IP[I-1] := IP[L-1];
  IP[L-1] := I;
  goto _90;
_80:
  IP[MIN-1] := I;
  IP[I-1] := I;
_90:
  IU[I-1] := JPI;
 end;
IU[N-1] := JP;
IU[NH-1] := JP;
end;

end.
